/// <reference types="node" />
import type { Options } from './unserialize';
export declare type ParserType = 'null' | 'int' | 'float' | 'boolean' | 'string' | 'array-object' | 'serializable-class' | 'notserializable-class';
export default class Parser {
    index: number;
    contents: Buffer;
    options: Options;
    constructor(contents: Buffer, index: number, options: Options);
    error(message?: string): Error;
    advance(index: number): void;
    readAhead(index: number): string;
    readUntil(expected: string): string;
    peekAhead(index: number): string;
    seekExpected(contents: string): void;
    getType(): ParserType;
    getLength(): number;
    getByLength<T>(startSequence: string, endSequence: string, callback: (length: number) => T): T;
}
